package server;

import io.Message;
import java.io.IOException;
import real.Item;
import real.ItemData;
import real.Player;

/**
 *
 * @author Văn Tú
 */
public class MenuController {

    Server server = Server.getInstance();

    public void sendMenu(Player p, Message m) throws IOException {
        byte b1 = m.reader().readByte();//idnpc
        byte b2 = m.reader().readByte();//class1
        byte b3 = m.reader().readByte();//class2
        m.cleanup();
        switch (p.typemenu) {
            //menu npc Tabemono
            case 4: {
                switch (b2) {
                    case 0:
                        p.requestItem(9);
                        break;
                    case 1:
                        p.requestItem(8);
                        break;
                }
                break;
            }
            //menu npc Kamakura
            case 5: {
                switch (b2) {
                    case 0:
                        p.requestItem(4);
                        break;
                }
                break;
            }
            //menu npc Tajima
            case 12: {
                if (b2 == 0) {
                    p.typemenu = 120;
                    doMenuArray(p, new String[]{"Hủy", "Ninja Kiếm", "Ninja Tiêu", "Ninja Kunai", "Ninja Cung", "Ninja Đao", "Ninja Quạt"});
                } else if (b2 == 1) {
                    for (Item item : p.nj.ItemBag) {
                        if (item == null)
                            continue;
                        if (ItemData.isTypeBody(item.id)) {
                            item.upgrade = 0;
                        }
                    }
                    p.nj.place.chatNPC(p, (short)b1, "Đã đưa hết trang bị có trong hành trang về cấp 0 , Con Phải Thoát Game Xong Vào Lại Hoàn Thành Việc Cho Về 0");
                } else {
                    p.nj.place.chatNPC(p, (short) b1, "Con đang thực hiện nhiệm vụ kiên trì diệt ác, hãy chọn Menu/Nhiệm vụ để biết mình đang làm đến đâu");
                }
                break;
            }
            //Menu npc Goosho
            case 26: {
                if (b2 == 0) {
                    p.requestItem(14);
                    break;
                } else if (b2 == 1) {
                    p.requestItem(15);
                    break;
                } else if (b2 == 2) {
                    p.requestItem(32);
                    break;
                }
            }
            //Menu npc tien nu
            case 33: {
                if (b2 == 0) {
                     if (10000000 < p.luong) {
                    p.conn.sendMessageLog("Bạn phải dưới 10 triệu lượng mới nhận được.");
                     return;
                   }
                    p.upluongMessage(10000000L);
                    break;
                }
               else if (b2 == 1) {
                     if (100000000 < p.nj.xu) {
                    p.conn.sendMessageLog("Bạn phải dưới 100 triệu xu mới nhận được.");
                     return;
                   }
                    p.nj.upxuMessage(100000000L);
                    break;
                } else
                 if (b2 == 2) {
                     if (p.nj.quantityItemyTotal(462) == 0) {
                     p.conn.sendMessageLog("Bạn Cần có kẹo tím.");
                    return;
                     }
                    p.updateExp(30000000L);
                    short[] arId = new short[]{434,478,462,478,435,382,383,384,435,476,476,647,647,612,612,535,535,645,645,478,462,462,478};
                    short idI = arId[util.nextInt(arId.length)];
                    Item itemup = ItemData.itemDefault(idI);
                   if (idI == 434 || idI == 435 || idI == 381 || idI == 382 || idI == 462 || idI == 476 || idI == 462 || idI == 647 || idI == 612 || idI == 535 || idI == 645 || idI == 478)
                             itemup.quantity = util.nextInt(1,20);
                    p.nj.addItemBag(true, itemup);
                    p.nj.removeItemBags(462, 1);
                    break;
                
                 } else if (b2 == 3) {
                     if (1000 > p.luong) {
                    p.conn.sendMessageLog("Bạn phải có 1k lượng mới đổi được.");
                     return;
                   }
                   p.updateExp(1000000L); 
                   p.upluongMessage(-1000L);
                    break;
                } else if (b2 == 4) {
                     server.manager.sendTB(p, "Hướng Dẫn", "Kiếm Kẹo Tím Bằng Cách Pk và Lật Hình Nhé");
                     break;
                }
            }
            //Menu npc Rakkii
            case 30: {
                switch (b2) {
                    case 0:
                        p.requestItem(38);
                        break;
                    case 2:
                        if (b3 == 0) {
                            server.manager.rotationluck[0].luckMessage(p);
                        } else if (b3 == 2) {
                            server.manager.sendTB(p, "Vòng xoay vip", "Tham gia đi xem luật lm gì");
                        }
                        break;
                    case 3:
                        if (b3 == 0) {
                            server.manager.rotationluck[1].luckMessage(p);
                        } else if (b3 == 2) {
                            server.manager.sendTB(p, "Vòng xoay thường", "Tham gia đi xem luật lm gì");
                        }
                        break;
                }
                break;
            }
            case 92:
                p.typemenu = ((b2 == 0) ? 93 : 94);
                doMenuArray(p, new String[]{"Thông tin", "Luật chơi"});
                break;
            case 93:
                if (b2 == 0) {
                    server.manager.rotationluck[0].luckMessage(p);
                } else if (b2 == 1) {
                    server.manager.sendTB(p, "Vòng xoay vip", "Tham gia đi xem luật lm gì");
                }
                break;
            case 94:
                if (b2 == 0) {
                    server.manager.rotationluck[1].luckMessage(p);
                } else if (b2 == 1) {
                    server.manager.sendTB(p, "Vòng xoay thường", "Tham gia đi xem luật lm gì");
                }
                break;
            case 95:
                break;
            case 120:
                if (b2 > 0 && b2 < 7) {
                    p.Admission(b2);
                }
                break;
            default:
                p.nj.place.chatNPC(p, (short) b1, "Chức năng này đang cập nhật...");
                break;

        }
        util.Debug("byte1 "+b1+" byte2 "+b2+" byte3 "+b3);
    }

    public void openUINpc(Player p, Message m) throws IOException {
        short idnpc = m.reader().readShort();//idnpc
        p.typemenu = idnpc;
        m.cleanup();
        m = new Message(40);
        m.writer().flush();
        if (idnpc == 12) {
            m.writer().writeUTF("Nhập học");
            m.writer().writeUTF("+0 TB");
        }
        else if (idnpc == 33) {
            m.writer().writeUTF("Nhận Lượng");
            m.writer().writeUTF("Nhận Xu");
            m.writer().writeUTF("Đổi Kẹo Tím");
            m.writer().writeUTF("Nhận Exp");
            m.writer().writeUTF("Hướng Dẫn");
        }
        p.conn.sendMessage(m);
        m.cleanup();
    }

    public void doMenuArray(Player p, String[] menu) throws IOException {
        Message m = new Message(63);
        for (byte i = 0; i < menu.length; i++) {
            m.writer().writeUTF(menu[i]);//menu
        }
        m.writer().flush();
        p.conn.sendMessage(m);
        m.cleanup();
    }
}
