package real;

import server.GameScr;

/**
 *
 * @author Văn Tú
 */
public class Body {
    
    private Ninja nj;
    protected byte speed = 4;
    public byte nclass = 0;
    public int level = 1;
    public long exp = 1;
    public long expdown = 0;
    protected long expr = 0;
    protected byte pk = 0;
    public byte typepk = 0;
    protected short ppoint = 0;
    protected short potential0 = 15;
    protected short potential1 = 5;
    protected int potential2 = 5;
    protected int potential3 = 5;
    protected short spoint = 0;
    public boolean isDie = false;
    public byte[] KSkill = null;
    public byte[] OSkill = null;
    public short CSkill = -1;
    public long CSkilldelay = 0;
    public short x = 0;
    public short y = 0;
    public int hp = 0;
    public int mp = 0;
    public int sys = 0;
    
    public void seNinja(Ninja nj) {
        this.nj = nj;
    }
    
    public int getMaxHP() {
        int hpmax = getPotential(2) * 10;
        hpmax = hpmax*(100+getPramItem(31))/100;
        hpmax = hpmax*(100+getPramItem(61))/100;
        hpmax += getPramItem(6);
        hpmax += getPramItem(32);
        hpmax += getPramItem(77);
        hpmax += getPramItem(82);
        hpmax += getPramItem(82);
        hpmax += getPramItem(125);
        if (hp > hpmax) {
            hp = hpmax;
        }
        return hpmax;
    }

    public synchronized void upHP(int hpup) {
        hp += hpup;
        if (hp > getMaxHP()) {
            hp = getMaxHP();
        }
        if (hp < 0) {
            isDie = true;
            hp = 0;
        }
    }

    public int getMaxMP() {
        int mpmax = getPotential(3) * 10;
        mpmax = mpmax*(100+getPramItem(28))/100;
        mpmax = mpmax*(100+getPramItem(60))/100;
        mpmax += getPramItem(7);
        mpmax += getPramItem(19);
        mpmax += getPramItem(29);
        mpmax += getPramItem(83);
        mpmax += getPramItem(117);
        if (mp > mpmax) {
            mp = mpmax;
        }
        return mpmax;
    }

    public synchronized void upMP(int mpup) {
        mp += mpup;
        if (mp > getMaxMP()) {
            mp = getMaxMP();
        }
    }

    public int eff5buffHP() {
        int efHP = 0;
        return efHP;
    }

    public int eff5buffMP() {
        int efMP = 0;
        return efMP;
    }
    
    public int speed() {
        int sp = speed;
        sp = sp*(100+getPramItem(16))/100;
        sp += getPramItem(93);
        return sp;
    }      

    public int dameBasic() {
        int basic = getPotential(0);
        if (nclass > 0 && nclass%2 == 0)
            basic += getPotential(3);
        basic += getPramItem(38);
        basic = basic*(100+getPramSkill(11))/100;
        return basic;
    }
    
    public int dameSide() {
        return 0;
    }
    
    public int dameSys() {
        int ds = 0;
        if (nclass > 0) {
            if (Sys() == 1) {
                ds = getPramSkill(2);
                if (nclass%2!=0) {
                    ds += getPramSkill(5);
                } else {
                    ds += getPramSkill(8);
                }
            } else if (Sys() == 2) {
                ds = getPramSkill(3);
                if (nclass%2!=0) {
                    ds += getPramSkill(6);
                } else {
                    ds += getPramSkill(9);
                }
            } else if(Sys() == 3) {
                ds = getPramSkill(4);
                if (nclass%2!=0) {
                    ds += getPramSkill(7);
                } else {
                    ds += getPramSkill(10);
                }
            }
        }
        return ds;
    }

    public int dameMax() {
        int dame = dameBasic();
        dame += dameSide();
        dame += dameSys();
        dame =  dame*(100+getPramItem(94))/100;
        dame += getPramItem(73);
        dame += getPramItem(87);
        if (dame < 0)
            dame = 0;
        return dame;
    }

    public int dameMin() {
        return dameMax() * 90 / 100;
    }
    
    public int dameDown() {
        int dwn = getPramItem(74);
        dwn += getPramItem(80);
        dwn += getPramItem(124);
        return dwn;
    }

    public int ResFire() {
        int bear = getPramItem(70);
        bear += getPramItem(96);
        return bear;
    }

    public int ResIce() {
        int bear = getPramItem(71);
        bear += getPramItem(95);
        return bear;
    }

    public int ResWind() {
        int bear = getPramItem(72);
        bear += getPramItem(97);
        return bear;
    }

    public int Exactly() {
        int exa = getPotential(1);
        exa += getPramItem(75);
        exa += getPramItem(86);
        exa += getPramItem(116);
        return exa;
    }

    public int Miss() {
        int mi = getPotential(1) * 150 / 100;
        mi += getPramItem(78);
        mi += getPramItem(84);
        mi += getPramItem(115);
        return mi;
    }

    public int Fatal() {
        int fat = getPramItem(69);
        fat += getPramItem(92);
        fat += getPramItem(114);
        return fat;
    }

    public int ReactDame() {
        int reactd = getPramItem(91);
        reactd += getPramItem(126);
        return reactd;
    }

    public int sysUp() {
        int su = 0;
        return su;
    }

    public int sysDown() {
        int sd = 0;
        return sd;
    }

    public int getPotential(int i) {
        int potential = 0;
        if (i == 0) {
            potential = potential0;
        } else if (i == 1) {
            potential = potential1;
        } else if (i == 2) {
            potential = potential2;
        } else if (i == 3) {
            potential = potential3;
        }
        potential += getPramItem(57);
        potential = potential * (100 + getPramItem(58)) / 100;
        return potential;
    }
    
    public int getPramItem(int id) {
        if (nj == null) {
            return 0;
        }
        int param = 0;
        for (Item body : nj.ItemBody) {
            if (body == null) {
                continue;
            }
            for (Option option : body.option) {
                if (option.id == id && !ItemData.isUpgradeHide(option.id, body.upgrade)) {
                    param += option.param;
                }
            }
        }
        for (Item mounts : nj.ItemMounts) {
            if (mounts == null) {
                continue;
            }
            for (Option option : mounts.option) {
                if (option.id == id) {
                    param += option.param;
                }
            }
        }
        return param;
    }

    public int getPramSkill(int id) {
        if (nj == null)
            return 0;
        int param = 0;
        for (Skill sk : nj.skill) {
            SkillData data = SkillData.Templates(sk.id);
            if (data.type != 0 && sk.id != CSkill)
                continue;
            SkillTemplates temp = SkillData.Templates(sk.id, sk.point);
            for (Option option : temp.options) {
                if (option.id == id) {
                    param += option.param;
                }
            }
        }
        return param;
    }
    
    private byte Sys() {
        return GameScr.SysClass(nclass);
    }
}
